


//There should only be one cart per country.

var otherCartPreferenceItems = null;

function AmazonCart(country) 
{
    
	this.country = country;
	items = null;
		
};

AmazonCart.prototype = new AmazonSearch;


AmazonCart.prototype.getTotal = function()
{
	return this.subtotal;
}

//if the cart was not created for any reason this must return false;
AmazonCart.prototype.cartExists = function()
{
	return(this.HMAC != null);

}

AmazonCart.prototype.cartCheckoutURL = function()
{
	return this.purchaseURL;
}



AmazonCart.prototype.addItem = function(item)
{
    
	//tell amazon.
	
	//update my list? or requery it completely?
	if(this.HMAC == null)
		this._createCart(item['asin']);
	else
		this._addItem(item['asin']);
	
    addCartItem(item );
	
}

AmazonCart.prototype.reloadPreferenceItems = function(items)
{
    
    if(this.HMAC == null)
    {
        otherCartPreferenceItems = items;
		this._createCart(items.pop()['asin']);
       
    }
}

AmazonCart.prototype.removeItem = function(item)
{

	
	this._removeItem(item['asin']);
    
     removeCartItem(item )
	
	
}

AmazonCart.prototype.clear = function()
{
	this._clear();

}

AmazonCart.prototype.loadItemList = function() 
{
	var domain = nodes[this.getCountry()]['domain_ecs'];
	var associate_id = nodes[this.getCountry()]['associates_id'];

	var feedURL = "http://" + domain +"/onca/xml?Service=AWSECommerceService&AWSAccessKeyId=" + accessKeyID + 
					"&Operation=CartGet&HMAC=" + this.HMAC + "&AssociateTag=" + associate_id + "&Version=2007-01-15&CartId=" + this.id;
					
	//widget.openURL(feedURL);
	
	var _self = this;
	
	var xmlRequest = new XMLHttpRequest();
	xmlRequest.open("GET", feedURL);
	xmlRequest.setRequestHeader("Cache-Control", "no-cache");
	xmlRequest.onreadystatechange = function (aEvt) 
	{
		if (xmlRequest.readyState == 4) 
		{
			//if(xmlRequest.status == 200)
			_self.xmlLoaded(xmlRequest);
			//bleh.xmlLoaded(xmlRequest);
			
			
		}
	};
	
	xmlRequest.send(null);
}



AmazonCart.prototype._addItem = function(asin)
{

	
	
	var domain = nodes[this.getCountry()]['domain_ecs'];
	var associate_id = nodes[this.getCountry()]['associates_id'];

	var feedURL = "http://" + domain +"/onca/xml?Service=AWSECommerceService&AWSAccessKeyId=" + accessKeyID + 
					"&Operation=CartAdd&HMAC=" + this.HMAC + "&AssociateTag=" + associate_id + "&Version=2007-01-15&Item.1.ASIN=" + asin + 
					"&Item.1.Quantity=1&CartId=" + this.id;
					
	//widget.openURL(feedURL);
	
	var _self = this;
	
	var xmlRequest = new XMLHttpRequest();
	xmlRequest.open("GET", feedURL);
	xmlRequest.setRequestHeader("Cache-Control", "no-cache");
	xmlRequest.onreadystatechange = function (aEvt) 
	{
		if (xmlRequest.readyState == 4) 
		{
			//if(xmlRequest.status == 200)
			_self._xmlAddCartItemLoaded(xmlRequest);
			//bleh.xmlLoaded(xmlRequest);
			
			
		}
	};
	
	xmlRequest.send(null);

}

AmazonCart.prototype._removeItem = function(asin)
{
	var itemId;

	var items = this.getItems();
	for(var i=0; i<items.length; i++)
	{
		if(asin == items[i]['asin'])
			itemId = items[i]['cartItemId'];
	}
	
	//alert("remove: " + itemId);
	
	var domain = nodes[this.getCountry()]['domain_ecs'];
	var associate_id = nodes[this.getCountry()]['associates_id'];

	//var feedURL = "http://" + domain +"/onca/xml?Service=AWSECommerceService&AWSAccessKeyId=" + accessKeyID + 
	//				"&Operation=CartModify&HMAC=" + this.HMAC + "&AssociateTag=" + associate_id + 
	//				"&Version=2007-01-15&Item.1.ASIN=" + asin + 
	//				"&Item.1.Quantity=0&CartItemId=" + itemId + "&CartId=" + this.id;
	
		var feedURL = "http://" + domain +"/onca/xml?Service=AWSECommerceService&AWSAccessKeyId=" + accessKeyID + 
					"&Operation=CartModify&HMAC=" + this.HMAC + "&AssociateTag=" + associate_id + 
					"&Item.1.CartItemId=" + itemId + "&Version=2007-01-15&Item.1.ASIN=" + asin + 
					"&Item.1.Quantity=0&CartId=" + this.id;
					
	//widget.openURL(feedURL);
	
	var _self = this;
	
	var xmlRequest = new XMLHttpRequest();
	xmlRequest.open("GET", feedURL);
	xmlRequest.setRequestHeader("Cache-Control", "no-cache");
	xmlRequest.onreadystatechange = function (aEvt) 
	{
		if (xmlRequest.readyState == 4) 
		{
			//if(xmlRequest.status == 200)
			_self._xmlRemoveCartItemLoaded(xmlRequest);
			//bleh.xmlLoaded(xmlRequest);
			
			
		}
	};
	
	xmlRequest.send(null);

	
}

AmazonCart.prototype._clear = function(asin)
{

	
	
	var domain = nodes[this.getCountry()]['domain_ecs'];
	var associate_id = nodes[this.getCountry()]['associates_id'];

	var feedURL = "http://" + domain +"/onca/xml?Service=AWSECommerceService&AWSAccessKeyId=" + accessKeyID + 
					"&Operation=CartClear&HMAC=" + this.HMAC + "&AssociateTag=" + associate_id + "&Version=2007-01-15&CartId=" + this.id;
					
	//widget.openURL(feedURL);
	
	var _self = this;
	
	var xmlRequest = new XMLHttpRequest();
	xmlRequest.open("GET", feedURL);
	xmlRequest.setRequestHeader("Cache-Control", "no-cache");
	xmlRequest.onreadystatechange = function (aEvt) 
	{
		if (xmlRequest.readyState == 4) 
		{
			//if(xmlRequest.status == 200)
			_self._xmlClearCartLoaded(xmlRequest);
			//bleh.xmlLoaded(xmlRequest);
			
			
		}
	};
	
	xmlRequest.send(null);

	
}




AmazonCart.prototype._createCart = function(asin)
{
	var domain = nodes[this.getCountry()]['domain_ecs'];
	var associate_id = nodes[this.getCountry()]['associates_id'];

	var feedURL = "http://" + domain +"/onca/xml?Service=AWSECommerceService&AWSAccessKeyId=" + accessKeyID + 
					"&Operation=CartCreate&AssociateTag=" + associate_id + "&Version=2007-01-15&Item.1.ASIN=" + asin + "&Item.1.Quantity=1";
	
	//widget.openURL(feedURL);
	
	var _self = this;
	
	var xmlRequest = new XMLHttpRequest();
	xmlRequest.open("GET", feedURL);
	xmlRequest.setRequestHeader("Cache-Control", "no-cache");
	xmlRequest.onreadystatechange = function (aEvt) 
	{
		if (xmlRequest.readyState == 4) 
		{
			//if(xmlRequest.status == 200)
			_self._xmlCreateCartLoaded(xmlRequest);
			//bleh.xmlLoaded(xmlRequest);
			
			
		}
	};
	
	xmlRequest.send(null);

}

AmazonCart.prototype._xmlClearCartLoaded = function(xmlRequest)
{
	if (xmlRequest.status == 200) 
	{
	
		try
		{
		
		
			xmlObj = xmlRequest.responseXML;

			//alert("************** " + xmlObj);
			//outputNodeNamesForNode(xmlObj);
			
			var cartClearResponse = xmlObj.getElementsByTagName("CartClearResponse")[0];

			//alert("************** " + cartClearResponse);
			//outputNodeNamesForNode(cartClearResponse);
		
		
			var cart = cartClearResponse.getElementsByTagName("Cart")[0];

			//alert("************** " + cart);
			//outputNodeNamesForNode(cart);
           // alert("items before reparse items: " + this.getItems().length());
			this._parseItemsFromNode(cart.getElementsByTagName("CartItems")[0]);
			//alert("parsed items: " + this.getItems().length());
            
			
			this._informDelegateOfSuccessfulLoad();
			
			
		}
		catch(err)
		{
			alert("failed to retrieve cart info from request. " + err);
			alert(xmlObj.responseText);
            
           
		}
	}
	else
	{
		alert("Error fetching data: HTTP status " + xmlRequest.status);
	}
    
   


} 


AmazonCart.prototype._xmlCreateCartLoaded = function(xmlRequest)
{
      
	if (xmlRequest.status == 200) 
	{
	
		try
		{
		
		
			xmlObj = xmlRequest.responseXML;
	
			//alert("************** " + createCartResponse);
			//outputNodeNamesForNode(xmlObj);
		
			
			var createCartResponse = xmlObj.getElementsByTagName("CartCreateResponse")[0];
		
			//alert("**************** " + createCartResponse);
			//outputNodeNamesForNode(createCartResponse);
		
		
			var cart = createCartResponse.getElementsByTagName("Cart")[0];
				
			//alert("**************");
			//outputNodeNamesForNode(cart);
			
			//function valueForKey(key,node)
			
			this.purchaseURL = valueForKey("PurchaseURL",cart);
			
			this.HMAC = valueForKey("URLEncodedHMAC",cart);
			
			this.id = valueForKey("CartId",cart);
			
			
			
			//alert("***********" + cartItems);
			//outputNodeNamesForNode(cartItems);
			
			this._parseItemsFromNode(cart.getElementsByTagName("CartItems")[0]);
			
			
			this._informDelegateOfSuccessfulLoad();
			
			//alert("got hmac: " + this.HMAC);
			//alert("got id: " + this.id);
		}
		catch(err)
		{
			alert("failed to retrieve cart info from request. " + err);
			alert(xmlObj.responseText);
		}
	}
	else
	{
		alert("Error fetching data: HTTP status " + xmlRequest.status);
	}
    
    if( otherCartPreferenceItems != null)
    {
        for(var i=0; i<otherCartPreferenceItems.length; i++)
        {
            this._addItem(otherCartPreferenceItems[i]['asin']);
          
        }
    }
    otherCartPreferenceItems = null;


} 


AmazonCart.prototype._xmlAddCartItemLoaded = function(xmlRequest)
{
  

	if (xmlRequest.status == 200) 
	{
	
		try
		{
		
		
			xmlObj = xmlRequest.responseXML;
	
			
			//alert("************** " + xmlObj);
			//outputNodeNamesForNode(xmlObj);
		
	
			var createCartResponse = xmlObj.getElementsByTagName("CartAddResponse")[0];
		
			//alert("**************** " + createCartResponse);
			//outputNodeNamesForNode(createCartResponse);
			
		
			var cart = createCartResponse.getElementsByTagName("Cart")[0];
			
			var cartItems = cart.getElementsByTagName("CartItems")[0];
			
			//alert("***********" + cartItems);
			//outputNodeNamesForNode(cartItems);
			
			this._parseItemsFromNode(cartItems);
			
			//alert("**************** " + cart);
			//outputNodeNamesForNode(cart);
			
			//var request = cart.getElementsByTagName("Request")[0];
			
			//var valid = valueForKey("IsValid",request)[0];
			
			//alert("valid: " + valid);
			
			
			this._informDelegateOfSuccessfulLoad();
		}
		catch(err)
		{
			alert("failed to retrieve cart info from request. " + err);
		}
	}
	else
	{
		alert("Error fetching data: HTTP status " + xmlRequest.status);
	}

} 

AmazonCart.prototype._xmlRemoveCartItemLoaded = function(xmlRequest)
{
	if (xmlRequest.status == 200) 
	{
	
		try
		{
		
		
			xmlObj = xmlRequest.responseXML;
	
			
			//alert("************** " + xmlObj);
			//outputNodeNamesForNode(xmlObj);
		
	
			var createCartResponse = xmlObj.getElementsByTagName("CartModifyResponse")[0];
		
			//alert("**************** " + createCartResponse);
			//outputNodeNamesForNode(createCartResponse);
			
		
			var cart = createCartResponse.getElementsByTagName("Cart")[0];
			
			var cartItems = cart.getElementsByTagName("CartItems")[0];
			
			//alert("***********" + cartItems);
			//outputNodeNamesForNode(cartItems);
			
			this._parseItemsFromNode(cartItems);
			
			//alert("**************** " + cart);
			//outputNodeNamesForNode(cart);
			
			//var request = cart.getElementsByTagName("Request")[0];
			
			//var valid = valueForKey("IsValid",request)[0];
			
			//alert("valid: " + valid);
			
			
			this._informDelegateOfSuccessfulLoad();
		}
		catch(err)
		{
			alert("failed to retrieve cart info from request. " + err);
		}
	}
	else
	{
		alert("Error fetching data: HTTP status " + xmlRequest.status);
	}

}

// Called when the XMLHttpRequest loads the feed
AmazonCart.prototype.xmlLoaded = function(xmlRequest) 
{
	
	

	if (xmlRequest.status == 200) 
	{
	
		try
		{

			xmlObj = xmlRequest.responseXML;
	
			//alert("************** " + xmlObj);
			//outputNodeNamesForNode(xmlObj);

	
			var cartGetResponse = xmlObj.getElementsByTagName("CartGetResponse")[0];
	
			//alert("************** " + cartGetResponse);
			//outputNodeNamesForNode(cartGetResponse);
	
			var cart = cartGetResponse.getElementsByTagName("Cart")[0];
	
			//alert("************** " + cart);
			//outputNodeNamesForNode(cart);
	
			var cartItems = cart.getElementsByTagName("CartItems")[0];
			
			//alert("***********" + cartItems);
			//outputNodeNamesForNode(cartItems);
			
			this._parseItemsFromNode(cartItems);
		
			/*
			var x = cartItems.childNodes;
	
			this.items = new Array();

			for (var i=0;i<x.length;i++)
			{ 
				var node = x[i];
				
				//alert("***********" + node.nodeName);
				//outputNodeNamesForNode(node);
				
				if(x[i].nodeName == "CartItem")
				{
					try
					{
						var item = new Array();
						item['cartItemId'] = valueForKey("CartItemId",node);
						item['asin'] = valueForKey("ASIN",node);
						item['title'] = valueForKey("Title",node);
						
					
						
						var itemTotal = node.getElementsByTagName("ItemTotal")[0];
				
						item['itemTotal'] = valueForKey("FormattedPrice",itemTotal);
				
						var price = node.getElementsByTagName("Price")[0];
						
						item['price'] = valueForKey("ItemPrice",null);
				
						
					
					
					}
					catch(err)
					{
						//alert("I don't think that's an amazon item. (" + x[i].nodeName +")");
					}
				}
				else if(x[i].nodeName == "SubTotal")
				{
					alert("amount: " + valueForKey("Amount",x[i]));
					
				}
				
				
			}
			*/
			
			
			/*
			anotherThing = otherThing.getElementsByTagName("BrowseNode")[0];
	
			response = anotherThing.getElementsByTagName(this.responseType)[0];
	
			//newReleases = anotherThing.getElementsByTagName("TopSellers")[0];
	
	
			x=response.childNodes;

			this.items = new Array();

			for (i=0;i<x.length;i++)
			{ 
				if (x[i].nodeType==1)
				{
			
					node = x[i];
					item = new Array();
					item['asin'] = valueForKey("ASIN",node);
					item['title'] = valueForKey("Title",node);
					
					this.items.push(item);
				}
			}
			*/
	
			
			
			this._informDelegateOfSuccessfulLoad();

			
		}
		catch(err)
		{
			alert("failed. " + err);
		}
		
	}
	else 
	{
		alert("Error fetching data: HTTP status " + xmlRequest.status);
	}
}

AmazonCart.prototype._parseItemsFromNode = function(node) 
{
	try
	{
		var x = node.childNodes;
	
			this.items = new Array();

			for (var i=0;i<x.length;i++)
			{ 
				var node = x[i];
				
				if(x[i].nodeName == "CartItem")
				{
					try
					{
						var item = new Array();
						item['cartItemId'] = valueForKey("CartItemId",node);
						//alert("cart item id: " + item['cartItemId']);
						item['asin'] = valueForKey("ASIN",node);
						item['title'] = valueForKey("Title",node);
						
						var itemTotal = node.getElementsByTagName("ItemTotal")[0];
						item['itemTotal'] = valueForKey("FormattedPrice",itemTotal);
				
						var price = node.getElementsByTagName("Price")[0];
						item['price'] = valueForKey("FormattedPrice",price);
						
                       
						
						this.items.push(item);
					
					}
					catch(err)
					{
						alert("I don't think that's an amazon item. (" + x[i].nodeName +")");
					}
				}
				else if(x[i].nodeName == "SubTotal")
				{
					//alert("amount: " + valueForKey("FormattedPrice",x[i]));
					this.subtotal = valueForKey("FormattedPrice",x[i]);
					
				}
				
				
			}
	}
	catch(err)
	{
		alert("unable to get items from node. " + err);
		alert("returning empty list.");
		this.items = new Array();
	}
	
	//alert("parsed " + this.items.length + " items.");
    
    

    
	return this.items;

}

