



var nodes;


function AmazonBrowseNode(type,aCountry,browseType,page)
{
		this.type = type;
		
		this.country = aCountry;
		
		if(browseType != null)
			this.responseType = browseType;
		else
			this.responseType = "NewReleases";
		
		if(page == null)
			page = 1;
		else
			this.page = page;
		
}

AmazonBrowseNode.prototype = new AmazonSearch;

AmazonBrowseNode.prototype.getChildNodes = function()
{
	return this.childNodes;
}

AmazonBrowseNode.prototype.loadSubnodes = function()
{
	
	var node = nodes[this.getCountry()][this.getType()];
	var domain = nodes[this.getCountry()]['domain_ecs'];
	
	var feedURL = "http://" + domain +"/onca/xml?Service=AWSECommerceService&AWSAccessKeyId=" + 
	accessKeyID + "&Operation=BrowseNodeLookup&BrowseNodeId=" + node +"&ResponseGroup=BrowseNodeInfo&Version=2007-04-04";
	
	//widget.openURL(feedURL);
	
	var xmlRequest = new XMLHttpRequest();

	var _self = this;
	xmlRequest.open("GET", feedURL);
	xmlRequest.setRequestHeader("Cache-Control", "no-cache");
	xmlRequest.onreadystatechange = function (aEvt) 
	{
		if (xmlRequest.readyState == 4) 
		{
			
			_self.xmlSubNodesLoaded(xmlRequest);
			
			
		}
	};
	
	xmlRequest.send(null);

	

}

AmazonBrowseNode.prototype.loadItemList = function() 
{

	//alert("load with node: " + node);
	//alert(this.getCountry() + " " + this.getType());
	if(this.node == null)
		var node = nodes[this.getCountry()][this.getType()];
	else
	{	
		//alert("use given node.");
		var node = this.node;
	}
	var domain = nodes[this.getCountry()]['domain_ecs'];
	
	
	
	// The feed to fetch
	var feedURL = "http://" + domain + "/onca/xml?Service=AWSECommerceService&AWSAccessKeyId=" + 
	accessKeyID + "&Operation=BrowseNodeLookup&BrowseNodeId="+ node + 
	"&ResponseGroup=" + this.responseType +"&Version=2007-04-04";
	
	
	
	//widget.openURL(feedURL);
	
	var xmlRequest = new XMLHttpRequest();

	var _self = this;
	xmlRequest.open("GET", feedURL);
	xmlRequest.setRequestHeader("Cache-Control", "no-cache");
	xmlRequest.onreadystatechange = function (aEvt) 
	{
		if (xmlRequest.readyState == 4) 
		{
			
			_self.xmlLoaded(xmlRequest);
			
			
		}
	};
	
	xmlRequest.send(null);


}

// Called when the XMLHttpRequest loads the feed
AmazonBrowseNode.prototype.xmlLoaded = function(xmlRequest) 
{
	
	

	if (xmlRequest.status == 200) 
	{
	
		try
		{

			xmlObj = xmlRequest.responseXML;
	
			thing = xmlObj.getElementsByTagName("BrowseNodeLookupResponse")[0];
	
			otherThing = thing.getElementsByTagName("BrowseNodes")[0];
	
			anotherThing = otherThing.getElementsByTagName("BrowseNode")[0];
	
			response = anotherThing.getElementsByTagName(this.responseType)[0];
	
			//newReleases = anotherThing.getElementsByTagName("TopSellers")[0];
			//outputNodeNamesForNode(anotherThing);
	
			x=response.childNodes;

			this.items = new Array();

			for (i=0;i<x.length;i++)
			{ 
				if (x[i].nodeType==1)
				{
			
					node = x[i];
					item = new Array();
					item['asin'] = valueForKey("ASIN",node);
					item['title'] = valueForKey("Title",node);
					
					this.items.push(item);
				}
			}
	
			
			
			try
			{
				
				this.delegate.searchDidFinish(this);
			}
			catch(err)
			{
				
			}

			
		}
		catch(err)
		{
			alert("failed. " + err);
		}
		
	}
	else 
	{
		alert("Error fetching data: HTTP status " + xmlRequest.status);
	}
}


// Called when the XMLHttpRequest loads the feed
AmazonBrowseNode.prototype.xmlSubNodesLoaded = function(xmlRequest) 
{
	
	

	if (xmlRequest.status == 200) 
	{
	
		try
		{

			var xmlObj = xmlRequest.responseXML;
	
			var response = xmlObj.getElementsByTagName("BrowseNodeLookupResponse")[0];
	
			var nodes = response.getElementsByTagName("BrowseNodes")[0];
	
			var node = nodes.getElementsByTagName("BrowseNode")[0];
	
			var children = node.getElementsByTagName("Children")[0];
	
			//outputNodeNamesForNode(children);
	
			x=children.childNodes;

			this.childNodes = new Array();

			item = new Array();
			
			//alert("node: " + getAmazonInfo()[this.getCountry()][this.getType()]);
			//alert("done.");
			item['name'] = "All";
			item['id'] = getAmazonInfo()[this.getCountry()][this.getType()];
			
			this.childNodes.push(item);

			for (i=0;i<x.length;i++)
			{ 
				if (x[i].nodeType==1)
				{
			
					node = x[i];
					item = new Array();
					item['name'] = valueForKey("Name",node);
					item['id'] = valueForKey("BrowseNodeId",node);
					
					//alert("name: " + valueForKey("Name",node));
					
					this.childNodes.push(item);
				}
			}
	
			
			
			try
			{
				this.delegate.childNodesDidLoad(this);
				//this.delegate.searchDidFinish(this);
			}
			catch(err)
			{
				
			}

			
		}
		catch(err)
		{
			alert("failed. " + err);
		}
		
	}
	else 
	{
		alert("Error fetching data: HTTP status " + xmlRequest.status);
	}
}










